#include <iostream.h>
#include "essai1.hxx"
#include "essai2.hxx"

Employe::Employe() {} ;
Engineer::Engineer() {} ;

Employe::Employe(int _age, int _sal, Ref<Dpt> dpt) {
  this->age = _age ;
  this->salary = _sal ;
  this->ref_dpt = dpt ;
}

void Employe::display() {

  cout << "\tAge     : " << this->age << "\n" ;
  cout << "\tSalary : " << this->salary << "\n" ;
  cout << "\tName : " << this->name << "\n" ;
} ;

void Engineer::display() {

  cout << "Engineer" ;
  this->Employe::display() ;
} ;

void Leader::display() {

  cout << "Leader" ;
  this->Employe::display() ;
} ;

void Employe::new_year(int augment) {

  this->age += 1 ;
  this->salary += this->salary / augment ;
}

void Dpt::displayAll() {

  Iterator<Employe> iter(this->emp) ;

  while(iter.more()) {
    iter.get()->display() ;
    iter.next() ;
  }
}
   


int main(int argc, char** argv) {

  yoo_connect("dept") ;

  Ref<Dpt> dpt ;

  if (yoo_getname(dpt, "APIC") == 0) {
    dpt = new Dpt ;
    yoo_setname(dpt, "APIC") ;
    dpt->ident = 5 ;

    Ref<Employe> emp = new Employe(0, 1000, dpt) ; 
    emp->name = "John" ;
    emp->age = 0 ;
    dpt->emp += emp ;
    emp->ref_dpt = dpt ;

    emp = new Engineer(1, 1000, dpt) ;
    emp->name = "Steve" ;
    emp->age = 1 ;
    dpt->emp += emp ;
    emp->ref_dpt = dpt ;

    emp = new Leader(2, 1000, dpt) ;
    emp->name = "Alan" ;
    emp->age = 2 ;
    dpt->emp += emp ;
    emp->ref_dpt = dpt ;

    emp = new Engineer(3, 1000, dpt) ;    
    emp->name = "Robert" ;
    emp->age = 3 ;
    dpt->emp += emp ;
    emp->ref_dpt = dpt ;
  }

  dpt->displayAll() ;


  yoo_commit() ;

  dpt->displayAll() ;

  yoo_disconnect() ;

} ;
